Bug 1649576 - Review Request: fix-info-plist-maven-plugin - Fix Info.plist file generated by p2-maven-plugin during Tycho build
Summary: Review Request: fix-info-plist-maven-plugin - Fix Info.plist file generated b...
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Jie Kang
QA Contact: Fedora Extras Quality Assurance
URL: https://github.com/buchen/fix-info-pl...
Whiteboard:
Depends On: 1649572
Blocks: 1649552
TreeView+ depends on / blocked
 
Reported: 2018-11-13 22:11 UTC by Salman Siddiqui
Modified: 2018-11-26 14:37 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2018-11-26 14:37:58 UTC
jkang: fedora-review+


Attachments (Terms of Use)
rpmlint - SPEC (58 bytes, text/plain)
2018-11-13 22:13 UTC, Salman Siddiqui
no flags Details
rpmlint - SRPM (118 bytes, text/plain)
2018-11-13 22:13 UTC, Salman Siddiqui
no flags Details
rpmlint - RPM (121 bytes, text/plain)
2018-11-13 22:14 UTC, Salman Siddiqui
no flags Details

Description Salman Siddiqui 2018-11-13 22:11:55 UTC
Spec URL: https://pagure.io/jmc-rpm/blob/master/f/fix-info-plist-maven-plugin/fix-info-plist-maven-plugin.spec
SRPM URL: https://copr-be.cloud.fedoraproject.org/results/sasiddiq/jmc/fedora-29-x86_64/00823525-fix-info-plist-maven-plugin/fix-info-plist-maven-plugin-1.2-1.fc29.src.rpm

Description: Just submitted my first package. I am seeking a sponsor.
Small Maven plugin to "fix" the Info.plist file generated by p2 during a Tycho
product build. This Maven plugin manipulates the Info.plist between the
materialize-products and archive-products goals of the P2 Directory Tycho
plugin to provide a custom Info.plist file for Eclipse RCP product.

Fedora Account System Username: sasiddiq
Successful Copr Build: https://copr.fedorainfracloud.org/coprs/sasiddiq/jmc/build/823525/

Comment 1 Salman Siddiqui 2018-11-13 22:13:32 UTC
Created attachment 1505466 [details]
rpmlint - SPEC

Comment 2 Salman Siddiqui 2018-11-13 22:13:46 UTC
Created attachment 1505467 [details]
rpmlint - SRPM

Comment 3 Salman Siddiqui 2018-11-13 22:14:04 UTC
Created attachment 1505468 [details]
rpmlint - RPM

Comment 5 Jie Kang 2018-11-20 19:26:59 UTC
The package will need to have a runtime dependency on dd-plist and xz-java as it does not include the packages in the jar it builds. It looks like the rpm build system adds the requires automatically but I think it's best to specify it explicitly.

Comment 6 Severin Gehwolf 2018-11-21 09:43:08 UTC
(In reply to Jie Kang from comment #5)
> The package will need to have a runtime dependency on dd-plist and xz-java
> as it does not include the packages in the jar it builds. It looks like the
> rpm build system adds the requires automatically but I think it's best to
> specify it explicitly.

I disagree, sorry.

The build generates this:

Requires(rpmlib): rpmlib(CompressedFileNames) <= 3.0.4-1 rpmlib(FileDigests) <= 4.6.0-1 rpmlib(PayloadFilesHavePrefix) <= 4.0-1
Requires: java-headless >= 1:1.7 javapackages-filesystem mvn(com.googlecode.plist:dd-plist) mvn(org.tukaani:xz)

Then in a mock with xz-java and dd-plist installed I see:

<mock-chroot> sh-4.4# rpm -q --whatprovides 'mvn(org.tukaani:xz)'
xz-java-1.8-3.fc29.noarch
<mock-chroot> sh-4.4# rpm -q --whatprovides 'mvn(com.googlecode.plist:dd-plist)'
dd-plist-1.21-1.fc30.noarch

Listing it explicitly will have the requirements in place twice and clutters the spec file.

Perhaps adding a comment that requirements will get generated by the maven requires generator is enough?

Comment 7 Jie Kang 2018-11-21 14:25:14 UTC
When you say requirements in place twice, do you mean the duplicate BR and R?

Sure, a comment works for me.

Comment 8 Severin Gehwolf 2018-11-21 14:35:55 UTC
(In reply to Jie Kang from comment #7)
> When you say requirements in place twice, do you mean the duplicate BR and R?

No. If an explicit "Requires: xz-java dd-plist" was being added, we'd have the same requirement twice in the binary rpm. Once via mvn()-requires, another time due to the above.

> Sure, a comment works for me.

Thanks!

Comment 9 Salman Siddiqui 2018-11-21 18:42:23 UTC
Updated.

Add comment about maven requires generator.

SPEC URL: https://copr-be.cloud.fedoraproject.org/results/sasiddiq/jmc/fedora-29-x86_64/00827653-fix-info-plist-maven-plugin/fix-info-plist-maven-plugin.spec

Comment 11 Jie Kang 2018-11-21 19:50:34 UTC
fix-info-plist-maven-plugin Package Review 1
============================================

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "*No copyright* EPL (v1.0)", "Unknown or generated", "EPL
     (v1.0)". 6 files have unknown license. Detailed output of licensecheck
     in /home/jkang/Work/fedora-reviews/fix-info-plist-maven-
     plugin/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Java:
[x]: Bundled jar/class files should be removed before build
[x]: Packages have proper BuildRequires/Requires on jpackage-utils
     Note: Maven packages do not need to (Build)Require jpackage-utils. It
     is pulled in by maven-local
[x]: Javadoc documentation files are generated and included in -javadoc
     subpackage
[x]: Javadoc subpackages should not have Requires: jpackage-utils
[x]: Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)

Maven:
[x]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: POM files have correct Maven mapping
[x]: Maven packages should use new style packaging
[x]: Old add_to_maven_depmap macro is not being used
[x]: Packages DO NOT have Requires(post) and Requires(postun) on jpackage-
     utils for %update_maven_depmap macro
[x]: Package DOES NOT use %update_maven_depmap in %post/%postun
[x]: Packages use .mfiles file list instead of %{_datadir}/maven2/poms

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in fix-
     info-plist-maven-plugin-javadoc
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[x]: Package uses upstream build method (ant/maven/etc.)
[x]: Packages are noarch unless they use JNI

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: fix-info-plist-maven-plugin-1.2-1.fc28.noarch.rpm
          fix-info-plist-maven-plugin-javadoc-1.2-1.fc28.noarch.rpm
          fix-info-plist-maven-plugin-1.2-1.fc28.src.rpm
fix-info-plist-maven-plugin.noarch: W: invalid-license EPL-1.0
fix-info-plist-maven-plugin-javadoc.noarch: W: invalid-license EPL-1.0
fix-info-plist-maven-plugin.src: W: invalid-license EPL-1.0
3 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
fix-info-plist-maven-plugin-javadoc.noarch: W: invalid-license EPL-1.0
fix-info-plist-maven-plugin-javadoc.noarch: W: invalid-url URL: https://github.com/buchen/fix-info-plist-maven-plugin <urlopen error [Errno -2] Name or service not known>
fix-info-plist-maven-plugin.noarch: W: invalid-license EPL-1.0
fix-info-plist-maven-plugin.noarch: W: invalid-url URL: https://github.com/buchen/fix-info-plist-maven-plugin <urlopen error [Errno -2] Name or service not known>
2 packages and 0 specfiles checked; 0 errors, 4 warnings.



Requires
--------
fix-info-plist-maven-plugin-javadoc (rpmlib, GLIBC filtered):
    javapackages-tools

fix-info-plist-maven-plugin (rpmlib, GLIBC filtered):
    java-headless
    javapackages-tools
    mvn(com.googlecode.plist:dd-plist)
    mvn(org.tukaani:xz)



Provides
--------
fix-info-plist-maven-plugin-javadoc:
    fix-info-plist-maven-plugin-javadoc

fix-info-plist-maven-plugin:
    fix-info-plist-maven-plugin
    mvn(name.abuchen:fix-info-plist-maven-plugin)
    mvn(name.abuchen:fix-info-plist-maven-plugin:pom:)



Source checksums
----------------
https://github.com/buchen/fix-info-plist-maven-plugin/archive/1.2.tar.gz :
  CHECKSUM(SHA256) this package     : 593afa805c2e6619931c4724e3cae18ec99cce9a073ecba17ffc0b963a496f5a
  CHECKSUM(SHA256) upstream package : 593afa805c2e6619931c4724e3cae18ec99cce9a073ecba17ffc0b963a496f5a


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review --rpm-spec -n ./srpms/fix-info-plist-maven-plugin-1.2-1.fc29.src.rpm -L rpms/
Buildroot used: fedora-28-x86_64
Active plugins: Generic, Shell-api, Java
Disabled plugins: C/C++, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Built with local dependencies:
    /home/jkang/Work/fedora-reviews/rpms/dd-plist-1.21-1.fc28.noarch.rpm

Comment 12 Gwyn Ciesla 2018-11-26 14:21:59 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/fix-info-plist-maven-plugin


Note You need to log in before you can comment on or make changes to this bug.